#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "TaskManager.h"

#define PREFIX "FACTORISATION: "

void factorisation_o1(struct InstanceStruct *instance){
	switch(instance->step){
		case 0:
			instance->memPtr = malloc(12);
			
			int tmp = open("number.txt", O_RDONLY);
			char *tmpb = malloc(24);
			read(tmp, tmpb, 24);
			close(tmp);
			tmpb[23] = 0;
			*(unsigned long long *)(instance->memPtr + 4) = strtoull(tmpb, NULL, 10);
			free(tmpb);
			
			*(int *)(instance->memPtr) = 1;
			instance->chanTrans = malloc(16 * sizeof(int));
			instance->chanTrans[0] = 2;
			instance->chanTrans[1] = 2;
			instance->chanTrans[2] = 3;
			instance->chanTrans[3] = 3;
			instance->chanTrans[4] = 4;
			instance->chanTrans[5] = 4;
			instance->chanTrans[6] = 5;
			instance->chanTrans[7] = 5;
			instance->chanTrans[8] = 6;
			instance->chanTrans[9] = 6;
			instance->chanTrans[10] = 7;
			instance->chanTrans[11] = 7;
			instance->chanTrans[12] = 8;
			instance->chanTrans[13] = 8;
			instance->chanTrans[14] = 9;
			instance->chanTrans[15] = 9;
			instance->step = 1;
			instance->state = READY;
			return;
		case 1:
			*(int *)(instance->memPtr) += 1;
			if(*(int *)(instance->memPtr) < 10){
				instance->nodeWait = *(int *)(instance->memPtr);
				instance->step = 1;
				instance->state = NODEWAIT;
				printf(PREFIX"NODEWAIT %d\n", instance->nodeWait);
			}
			else{
				instance->step = 2;
				instance->state = READY;
			}
			return;
		case 2:
			instance->comSize = sizeof(struct SpawnStruct);
			instance->comPtr = malloc(instance->comSize);
			((struct SpawnStruct*)instance->comPtr)->name = malloc(5);
			strcpy(((struct SpawnStruct*)instance->comPtr)->name,"work_o1");
			((struct SpawnStruct*)instance->comPtr)->peerId = 1;
			((struct SpawnStruct*)instance->comPtr)->ctSize = 2 * sizeof(int);
			((struct SpawnStruct*)instance->comPtr)->chanTrans = malloc(2 * sizeof(int));
			((struct SpawnStruct*)instance->comPtr)->chanTrans[0] = 1;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[1] = 1;
			instance->step = 3;
			instance->state = READY;
			return;
		case 3:
			((struct SpawnStruct*)instance->comPtr)->peerId += 1;
			if(((struct SpawnStruct*)instance->comPtr)->peerId < 10){
				((struct SpawnStruct*)instance->comPtr)->chanTrans[0] = ((struct SpawnStruct*)instance->comPtr)->peerId;
				instance->step = 3;
				instance->state = SPAWN;
				printf(PREFIX"SPAWN %d\n", ((struct SpawnStruct*)instance->comPtr)->peerId);
			}
			else{
				free(((struct SpawnStruct*)instance->comPtr)->name);
				free(((struct SpawnStruct*)instance->comPtr)->chanTrans);
				free(instance->comPtr);
				instance->localCh = -2;
				instance->comSize = 8;
				instance->step = 4;
				instance->state = READY;
			}
			return;
		case 4:
			instance->localCh += 2;
			if(instance->localCh < 15){
				instance->comSize = 8;
				instance->comPtr = instance->memPtr + 4;
				instance->step = 4;
				instance->state = CHANW;
				printf(PREFIX"SEND %llu TO %d:%d\n", *(unsigned long long *)(instance->memPtr + 4), instance->chanTrans[instance->localCh], instance->chanTrans[instance->localCh + 1]);
			}
			else{
				instance->localCh = -2;
				instance->step = 5;
				instance->state = READY;
			}
			return;
		case 5:
			instance->localCh += 2;
			if(instance->localCh < 15){
				instance->comPtr = instance->memPtr + 4;
				instance->comSize = 8;
				instance->step = 5;
				instance->state = CHANR;
			}
			else{
				instance->step = 6;
				instance->state = READY;
			}
			return;
		case 6:
			printf(PREFIX"DONE\n");
			exit(0);
			free(instance->memPtr);
			instance->step = 0;
			instance->state = DONE;
			return;
	}
}