#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "TaskManager.h"

void simple(struct InstanceStruct *instance){
	switch(instance->step){
		case 0:
			instance->memPtr = malloc(4);
			instance->chanTrans = malloc(4 * sizeof(int));
			instance->chanTrans[0] = 2;
			instance->chanTrans[1] = 2;
			instance->chanTrans[2] = 3;
			instance->chanTrans[3] = 3;
			instance->step = 1;
			instance->state = READY;
			return;
		case 1:
			instance->nodeWait = 2;
			instance->step = 2;
			instance->state = NODEWAIT;
			return;
		case 2:
			instance->nodeWait = 3;
			instance->step = 3;
			instance->state = NODEWAIT;
			return;
		case 3:
			instance->comSize = sizeof(struct SpawnStruct);
			instance->comPtr = malloc(instance->comSize);
			((struct SpawnStruct*)instance->comPtr)->name = malloc(3);
			strcpy(((struct SpawnStruct*)instance->comPtr)->name,"f1");
			((struct SpawnStruct*)instance->comPtr)->peerId = 2;
			instance->step = 4;
			instance->state = TRANSFER;
			return;
		case 4:
			strcpy(((struct SpawnStruct*)instance->comPtr)->name,"f2");
			((struct SpawnStruct*)instance->comPtr)->peerId = 3;
			instance->step = 5;
			instance->state = TRANSFER;
			return;
		case 5:
			strcpy(((struct SpawnStruct*)instance->comPtr)->name,"f1");
			((struct SpawnStruct*)instance->comPtr)->peerId = 2;
			((struct SpawnStruct*)instance->comPtr)->ctSize = 4 * sizeof(int);
			((struct SpawnStruct*)instance->comPtr)->chanTrans = malloc(4 * sizeof(int));
			((struct SpawnStruct*)instance->comPtr)->chanTrans[0] = 1;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[1] = 3;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[2] = 2;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[3] = 1;
			instance->step = 6;
			instance->state = SPAWN;
			return;
		case 6:
			strcpy(((struct SpawnStruct*)instance->comPtr)->name,"f2");
			((struct SpawnStruct*)instance->comPtr)->peerId = 3;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[0] = 1;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[1] = 2;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[2] = 3;
			((struct SpawnStruct*)instance->comPtr)->chanTrans[3] = 1;
			instance->step = 7;
			instance->state = SPAWN;
			return;
		case 7:
			free(((struct SpawnStruct*)instance->comPtr)->name);
			free(((struct SpawnStruct*)instance->comPtr)->chanTrans);
			free(instance->comPtr);
			instance->localCh = 0;
			instance->comPtr = instance->memPtr;
			instance->comSize = 4;
			instance->step = 8;
			instance->state = CHANR;
			return;
		case 8:
			instance->localCh = 2;
			instance->comPtr = instance->memPtr;
			instance->comSize = 4;
			instance->step = 9;
			instance->state = CHANR;
			return;
		case 9:
			printf("DONE!\n");
			instance->state = READY;
			instance->step = 10;
			return;
		case 10:
			free(instance->memPtr);
			instance->memPtr = NULL;
			instance->state = DONE;
			instance->step = 0;
			return;
	}
}