#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "TaskManager.h"

#define PREFIX "WORK: "

void work(struct InstanceStruct *instance){
	switch(instance->step){
		case 0:
			instance->memPtr = malloc(16);
			instance->step = 1;
			instance->state = READY;
			return;
		case 1:
			instance->localCh = 0;
			instance->comPtr = instance->memPtr;
			instance->comSize = 8;
			instance->step = 2;
			instance->state = CHANR;
			return;
		case 2:
			*(unsigned long long*)(instance->memPtr + 8) = 2;
			if(*(unsigned long long*)(instance->memPtr) == 1)
				instance->step = 4;
			else
				instance->step = 3;
			instance->state = READY;
			return;
		case 3:
			if(*(unsigned long long*)(instance->memPtr) % *(unsigned long long*)(instance->memPtr + 8) == 0){
				*(unsigned long long*)(instance->memPtr) /= *(unsigned long long*)(instance->memPtr + 8);
				printf(PREFIX"Factor: %llu (%llu left)\n", *(unsigned long long*)(instance->memPtr + 8), *(unsigned long long*)(instance->memPtr));
				instance->step = 2;
			}
			else{
				(*(unsigned long long*)(instance->memPtr + 8))++;
				instance->step = 3;
			}
			instance->state = READY;
			return;
		case 4:
			instance->localCh = 0;
			instance->comPtr = instance->memPtr;
			instance->comSize = 8;
			instance->step = 5;
			instance->state = CHANW;
			return;
		case 5:
			free(instance->memPtr);
			instance->step = 0;
			instance->state = DONE;
			break;
	}
}