#ifndef _FUNCTIONMANAGER_H
#define _FUNCTIONMANAGER_H

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

struct InstanceStruct;

struct FunStruct{
	char *name;
	FILE *file;
	void *handle;
	void (*fun)(struct InstanceStruct *);
};


int fm_init();
int fm_writeToFile(char *name, char *data, int len, int remainder);
int fm_createInstance(char *name, int *chanTrans);
int fm_loadFunction(char *name);
int fm_readFunction(char *name, void **ptr, unsigned long *fileLen);

#endif //_FUNCTIONMANAGER_H