#ifndef _PEER_HASH_H
#define _PEER_HASH_H

#define NPEERBUCKETS 64

struct PeerHash{
	int id;
	struct PeerList *peer;
	struct InstanceStruct *waitingInstance;
	struct PeerHash *next;
};


int ph_init();
int ph_add(struct PeerList *peer);
int ph_waitForNode(struct InstanceStruct *instance, int id);
struct PeerList *ph_getPeer(int id);

#endif//_PEER_HASH_H